
/**
 * Created by IntelliJ IDEA.
 * Author: Alexandre Koubenski
 *
 * ,       .
 *     " ",    
 *        .
 *
 */
public class QuickSort {
    /**
     * ,      ,  
     *     .   
     *       ( 
     *     )
     *
     * @param n -  
     * @return  -     n.
     */
    static int log(int n) {
        int l = 0;
        //   ,     
        while(n > 0) { n >>= 1; l++; }
        //  -  
        return l;
    }

    /**
     * ,         
     */
    static class Bounds {
        int low, high;
        Bounds(int low, int high) { this.low = low; this.high = high; }
    }

    /**
     *      
     */
    static class Storage {
        Bounds[] stor;      //  
        int size = 0;       //    

        //     
        Storage(int l) { stor = new Bounds[l]; }
        //    
        boolean isEmpty() { return size == 0; }
        //    ( push)
        void put(Bounds b) { stor[size++] = b; }
        //    ( pop)
        Bounds get() { return stor[--size]; }
    }

    /**
     *   
     * @param array  - ,  
     * @return       -   ( ,   ,  
     *                     )
     */
    public static int[] quickSort(int[] array) {
        //       
        Storage s = new Storage(log(array.length));
        //      
        int low = 0, high = array.length;
        //  ,    
        for (;;) {
            //         low  high
            int l = low, h = high;
            int c = array[low];     // " "    
            //        c
            while (l < h) {
                while (l < h && array[--h] >= c);  array[l] = array[h];
                while (l < h && array[++l] <= c);  array[h] = array[l];
            }
            array[l] = c;

            //           
            if (l - low <=1 && high - l <= 2) {
                //     ,     .
                //     ,    .
                if (s.isEmpty()) break; else { Bounds b = s.get(); low = b.low; high = b.high; }
            } else if (l - low <= 1) {
                //         
                low = l+1;
            } else if (high - l <= 2) {
                //        
                high = l;
            } else if (l - low < high - l - 1) {
                //        
                s.put(new Bounds(l+1, high)); high = l;
            } else {
                s.put(new Bounds(low, l)); low = l+1;
            }
        }
        //   
        return array;
    }

    /**
     *    
     * @param arr -  
     */
    public static void printArray(int[] arr) {
        System.out.print('[');
        for (int i = 0; i < arr.length; i++) {
            String outString = Integer.toString(arr[i]);
            if (i < arr.length-1) outString = outString + ',';
            System.out.print(outString);
        }
        System.out.println(']');
    }

    /**
     *        
     *  
     *
     * @param args
     */
    public static void main(String[] args) {
        //     ""  ,
        //      
        printArray(quickSort(new int[]
            {3,2,1,6,5,4,9,8,7,12,11,10,15,14,13,18,17,16,21,20,19,24,23,22,27,26,25,30,29,28}
        ));
    }
}
